//+------------------------------------------------------------------+
//|                                                      YTT2 EA.mq4 |
//|                                      Copyright  2006, Eli Hayun |
//|                                          http://www.elihayun.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Eli Hayun"
#property link      "http://www.elihayun.com"

#define DOWN_TREND -1
#define UP_TREND    1
#define NEUTRAL     0



extern double lots=1.0;
extern int MaxTrades=1;
extern bool ManageMoney = true;
extern int Risk = 2;
extern bool ProfitTrailing = true;  
extern bool UseSound = true;  

extern int StopLoss = 50;
extern int TakeProfit = 10;
extern int TrailingStop = 8; 

extern int timeframe = PERIOD_M15;
  
int TrailingStep = 1;   
string NameFileSound  = "expert.wav";  

int MagicNum = 12344355;


int Bands_Period=20;
int Bands_Deviation=2;
int Power_Period=13;

void deinit() {
   Comment("");
}

//--------------------------------------------------------------------------------------// 

int orderscnt(){
int cnt=0;
   for(int i =0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()==Symbol() && MagicNum==OrderMagicNumber()){
            cnt++;
         }
      }
   }
   return(cnt);
}

//--------------------------------------------------------------------------------------// 

int start(){

  //if (!NewBar())
  // return(0);
   
   for (int i=0; i<OrdersTotal(); i++) {
       if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
         TrailingPositions();
      }
   }

   if(orderscnt()<MaxTrades){
      if(ManageMoney==true) lots = LotSize();
      if (MathMod(Minute(),Period()) >= 0.5*Period()) return(0);
      CheckOpen();
   }   
}

//--------------------------------------------------------------------------------------// 

void CheckOpen(){
 
  bool Buy = false, Sell=false;

   Buy  = CheckBuySell(OP_BUY);
   Sell = CheckBuySell(OP_SELL);

  
   double TP,SL;
//--------------------------------------------------------------------------------------// 
   if (Buy){
      if(StopLoss==0){SL=0;}else{SL=Ask-StopLoss*Point;}
      if(TakeProfit==0){TP=0;}else{TP=Ask+TakeProfit*Point;}
      OrderSend(Symbol(),OP_BUY,lots,Ask,1,SL,TP,"YTT2 "+Period(),MagicNum,0,LawnGreen); 
   }
   if (Sell){
      if(StopLoss==0){SL=0;}else{SL=Bid+StopLoss*Point;}
      if(TakeProfit==0){TP=0;}else{TP=Bid-TakeProfit*Point;}
      OrderSend(Symbol(),OP_SELL,lots,Bid,1,SL,TP,"YTT2 "+Period(),MagicNum,0,HotPink); 
   }
}
//--------------------------------------------------------------------------------------// 
double LotSize(){
   double lotMM = MathCeil(AccountFreeMargin() * Risk / 1000)/10;  
   if (lotMM < 0.1) lotMM = lots;
   if (lotMM > 1.0) lotMM = MathCeil(lotMM);
   if  (lotMM > 50) lotMM = 50;
   return (lotMM);
} 
//--------------------------------------------------------------------------------------// 
void TrailingPositions() {
  double pBid, pAsk, pp;

  pp = MarketInfo(OrderSymbol(), MODE_POINT);
  if (OrderMagicNumber() != MagicNum)
   return;
  
  if (OrderType()==OP_BUY) 
  {
    pBid = MarketInfo(OrderSymbol(), MODE_BID);
    if (!ProfitTrailing || (pBid-OrderOpenPrice())>TrailingStop*pp) 
    {
      if (OrderStopLoss()<pBid-(TrailingStop+TrailingStep-1)*pp) 
      {
        ModifyStopLoss(pBid-TrailingStop*pp);
        return;
      }
    }
  }
  if (OrderType()==OP_SELL) 
  {
    pAsk = MarketInfo(OrderSymbol(), MODE_ASK);
    if (!ProfitTrailing || OrderOpenPrice()-pAsk>TrailingStop*pp) 
    {
      if (OrderStopLoss()>pAsk+(TrailingStop+TrailingStep-1)*pp || OrderStopLoss()==0) 
      {
        ModifyStopLoss(pAsk+TrailingStop*pp);
        return;
      }
    }
  }
}
//--------------------------------------------------------------------------------------// 
void ModifyStopLoss(double ldStopLoss) {
  bool fm;

  if (OrderMagicNumber() != MagicNum)
   return;
  fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,Yellow);
  if (fm && UseSound) PlaySound(NameFileSound);
}
//--------------------------------------------------------------------------------------// 

bool NewBar()
{

   static datetime dt = 0;
   if (iTime(NULL,timeframe, 0) != dt)
   {
      dt = iTime(NULL,timeframe, 0);
      //Print(TimeToStr(dt),"  ");
      return(true);
   }
   return(false);
}

void drawline(color clr)
{
   static int ix = 1;
   ObjectCreate("ln"+ix, OBJ_VLINE, 0, iTime(NULL, timeframe, 0), Ask);
   ObjectSet("ln"+ix, OBJPROP_COLOR, clr);
   ix++;
   
}

// add logic here 
// CheckBuySell will check if it is safe to buy or safe to sell according to op parameter
// op : OP_BUY or OP_SELL
bool CheckBuySell(int op)
{
   int tf = 0;
   int Power_Price = 0;
   int sum = 0;
   int dDown = 0; int dUp = 0;
   
   for (int ii=0; ii< 5; ii++)
   {
      switch (ii)
      {
         case 0: tf = 5; break;
         case 1: tf = 15; break;
         case 2: tf = 30; break;
         case 3: tf = 60; break;
         case 4: tf = 240; break;
      }

      double v1_1 =iClose(NULL, tf, 1) -iBands(NULL,tf,Bands_Period,Bands_Deviation,0,MODE_MAIN,Power_Price,1);
      double v2_1 =-(iBearsPower(NULL,tf,Power_Period,Power_Price,1)+iBullsPower(NULL,tf,Power_Period,Power_Price,1));


      double v1 =iClose(NULL, tf, 0) -iBands(NULL,tf,Bands_Period,Bands_Deviation,0,MODE_MAIN,Power_Price,0);
      double v2 =-(iBearsPower(NULL,tf,Power_Period,Power_Price,0)+iBullsPower(NULL,tf,Power_Period,Power_Price,0));
      int p = MathAbs(v1-v2)/Point; 
      sum +=  p;
      if (v1_1 > v2_1) dDown++;
      if (v1_1 < v2_1) dUp++;
  }
   sum /= 5;
   

   if (op == OP_BUY)
   {
      if ((sum < 20) && (dUp > 4))
         return(true);   
   }
   
   if (op == OP_SELL)
   {
      if ((sum < 20) && (dDown > 4))
         return(true);   
   }
   return(false);
}

